package fr.sanchezm.attestationsCovid19.data.db

import android.content.Context
import fr.sanchezm.attestationsCovid19.data.db.dao.AttestationDao
import fr.sanchezm.attestationsCovid19.data.db.dao.ProfileDao

class MyDatabase private constructor(private val savePath: String, private val filesPath: String) {

    private var _profileDao: ProfileDao? = null
    private var _attestationDao: AttestationDao? = null

    fun profileDao(): ProfileDao = _profileDao ?: ProfileDao(savePath).also { _profileDao = it }

    fun attestationDao(): AttestationDao =
        _attestationDao ?: AttestationDao(savePath, filesPath).also { _attestationDao = it }

    companion object {
        @Volatile
        private var instance: MyDatabase? = null
        private val LOCK = Any()

        operator fun invoke(context: Context, filesPath: String) = instance ?: synchronized(LOCK) {
            instance ?: MyDatabase(context.filesDir.path, filesPath).also { instance = it }
        }
    }
}

/*
import android.content.Context
import androidx.room.Database
import androidx.room.Room
import androidx.room.RoomDatabase
import fr.sanchezm.attestationsCovid19.data.db.dao.AttestationDao
import fr.sanchezm.attestationsCovid19.data.db.dao.ProfileDao
import fr.sanchezm.attestationsCovid19.data.db.entity.Profile

@Database(
    entities = [Profile::class],
    version = 1
)
abstract class MyDatabase private constructor() : RoomDatabase() {

    abstract fun profileDao(): ProfileDao
    abstract fun attestationDao(): AttestationDao

    companion object {
        @Volatile
        private var instance: MyDatabase? = null
        private val LOCK = Any()

        operator fun invoke(context: Context) = instance ?: synchronized(LOCK) {
            instance ?: buildDatabase(context).also { instance = it }
        }

        private fun buildDatabase(context: Context) =
            Room.databaseBuilder(
                context.applicationContext,
                MyDatabase::class.java, "data.db"
            )
                .build()
    }
}
*/
