package fr.sanchezm.attestationsCovid19.ui.attestations

import android.view.View
import androidx.lifecycle.LiveData
import androidx.lifecycle.MutableLiveData
import androidx.lifecycle.ViewModel
import fr.sanchezm.attestationsCovid19.data.repository.AttestationRepository
import fr.sanchezm.attestationsCovid19.utilities.Event

class AttestationsViewModel(attestationRepository: AttestationRepository) : ViewModel() {

    private val _startActivity = MutableLiveData<Event<Long>>()
    private var _displayNoAttestation = MutableLiveData<Int>()

    val attestations = attestationRepository.getAttestations()
    val startActivity: LiveData<Event<Long>> = _startActivity
    val displayNoAttestation: LiveData<Int> = _displayNoAttestation

    init {
        if (attestations.value == null || attestations.value?.size == 0) {
            _displayNoAttestation.value = View.VISIBLE
        } else {
            _displayNoAttestation.value = View.GONE
        }
    }

}