package fr.sanchezm.attestationsCovid19.utilities

import android.graphics.Bitmap
import com.google.zxing.BarcodeFormat
import com.google.zxing.MultiFormatWriter
import com.journeyapps.barcodescanner.BarcodeEncoder
import fr.sanchezm.attestationsCovid19.data.db.entity.Attestation


class QRCodeUtils {

    companion object {
        fun getQrCode(attestation: Attestation, size: Int): Bitmap =
            BarcodeEncoder().createBitmap(getMultiFormatWriter(attestation, size))

        private fun getMultiFormatWriter(attestation: Attestation, size: Int) =
            MultiFormatWriter().encode(attestation.toString(), BarcodeFormat.QR_CODE, size, size)
    }
}